Installation
------------
Install MOOGLI from PyPI:

pip install moogli

MOOGLI can be built and installed from sources (in current directory)
using python distutils:

sudo python setup.py install

If you do not have administrative privileges, moogli can be installed in your home directory using:

python setup.py install --user

libqt4-dev
PyQT4
python-qt4-dev 
python-qt4-gl
python-sip
libopenscenegraph 
libopenscenegraph-dev


Troubleshooting
----------------

**Error**

sipAPI_moogli.h:13:21: fatal error: QMetaType: No such file or directory

**Solution**
make sure you install Qt4 development libraries (
`apt-get install libqt4-dev` on debian/ubuntu type systems).

To obtain this for cygwin, use cygwin ports: 
`cygstart -- /path/to/setup-x86.exe -K http://cygwinports.org/ports.gpg`

and then select All->Libs->libQtGui4-devel for installation (type it in the
search box to find it easily)

However, moogli does not compile on cygwin yet because the dependency
OpenSceneGraph is not available for cygwin. If you want to try,
OpenSceneGraph build instruction are here:

http://trac.openscenegraph.org/projects/osg//wiki/Support/PlatformSpecifics/Cygwin

and some patches from prior attempts here:

https://cygwin.com/ml/cygwin-apps/2009-06/msg00134.html

**Error**

  sip: Unable to find file "QtGui/QtGuimod.sip"

**Solution**

  Install python-qt4-dev

**Error**

./moogli/include/utility/libraries.hpp:26:21: fatal error: osg/Shape: No such file or directory

**Solution**

 Install libopenscenegraph-dev
